Ice Reference Documentation
<<< Previous | Properties | Next >>>

# Ice Thread Pool Properties

## Ice.ThreadPool.Client.Size, Ice.ThreadPool.Server.Size

### Synopsis

    Ice.ThreadPool.Client.Size=num
    Ice.ThreadPool.Server.Size=num

### Description

A communicator creates two thread pools: the client thread pool dispatches AMI callbacks and incoming requests on bidirectional connections, and the server thread pool dispatches requests to object adapters. `num` is the initial and also minimum number of threads in the thread pool. The default value is one for both properties.

An object adapter can also be configured with its own thread pool. See the object adapter properties for more information.

| Multiple threads for the client thread pool are only required for nested AMI invocations. If AMI is not used, or AMI calls are not nested (i.e., AMI callbacks do not invoke any other operations on Ice objects), then there is no need to set the number of threads in the client thread pool to a value larger than one.

## Ice.ThreadPool.Client.SizeMax, Ice.ThreadPool.Server.SizeMax

### Synopsis

    Ice.ThreadPool.Client.SizeMax=num
    Ice.ThreadPool.Server.SizeMax=num

### Description

`num` is the maximum number of threads for the thread pool. Thread pools in Ice can grow and shrink dynamically, based on an average load factor. Thread pools do not grow larger than the number specified by `SizeMax`, and they do not shrink to a number of threads smaller than the value specified by `Size`.

The default value for `SizeMax` is the value of `Size`, meaning that by default, thread pools do not grow dynamically.

## Ice.ThreadPool.Client.SizeWarn, Ice.ThreadPool.Server.SizeWarn

### Synopsis

    Ice.ThreadPool.Client.SizeWarn=num
    Ice.ThreadPool.Server.SizeWarn=num

### Description

Whenever `num` threads are active in a thread pool, a "low on threads" warning is printed. The default value for `SizeWarn` is 80% of the value specified by `SizeMax`.

## Ice.ThreadPool.Client.StackSize, Ice.ThreadPool.Server.StackSize

### Synopsis

    Ice.ThreadPool.Client.StackSize=num
    Ice.ThreadPool.Server.StackSize=num

### Description

`num` is the stack size (in bytes) of threads in the thread pool. The default value is zero meaning the operating system's default is used.

<<< Previous | Home | Next >>>
Ice Plugin Properties | Up | Ice Default and Override Properties